#include <bits/stdc++.h>
using namespace std;
int max(int a[],int n){
	int m=a[0];
	for(int i=1;i<=n;i++){
		if(m<=a[i]){
			m=a[i];
		}
	}
	return m;
}
void brisi(int a[],int n,int x){
	for(int i=0;i<n;i++){
		if(a[i]==x){
			int p=a[i+1];
			a[i+1]=a[i];
			a[i]=p;
		}
	}
}
bool provera(int a[],int n){
	for(int i=0;i<n-1;i++){
		if(a[i]>a[i+1]){
			return false;
		}
	}
	return true;
}
int main()
{
    ios_base::sync_with_stdio(false);
	cin.tie(NULL);
    int n,a[200000],q,l[100000],r[100000];
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>l[i]>>r[i];
    }
    for(int i=0;i<q;i++){
    	if(l[i]==r[i]){
			cout<<"DA"<<endl;
			break;
		}
        int x[n];
        int p=0;
        for(int j=l[i]-1;j<r[i];j++){
            x[p]=a[j];
            p++;
        }
        int m=max(x,p);
		while(m==x[p]){
			brisi(x,p,m);
		}
		m=max(x,p);
		brisi(x,p,m);
		if(provera(x,p)){
			cout<<"DA"<<endl;
		}else{
			cout<<"NE"<<endl;
		}
    }
    
 return 0;
}